option mprint mlogic symbolgen;

/*no value is assigned for the %bquote and %nrbquote,*/
/*but "DO:+=" is assigned for the %quote and %nrquote*/
%macro example;
%let s=       %str(do:+=;&sysday );
%let n =    %nrstr(do:+=;&sysday );

%let q=     %quote(do:+=;&sysday );
%let nrq= %nrquote(do:+=;&sysday );

%let bq=   %bquote(do:+=;&sysday );
%let nrb=%nrbquote(do:+=;&sysday );

%let sp=   %superq(do:+=;&sysday );

%put s=&s  ***n=&n  ***q=&q  ***nrq=&nrq  ***bq=&bq  ***nrb=&nrb  ***sp=&sp;
%mend;

%example;



/*************************************************************************
   another example to illustrate compile-phase and execute-phase functions
*************************************************************************/
*,;*';*);%mend;run;

%macro ex(p);
%if %nrbquote(&p)= %then
     %put %str(warning ==>;-%(  missing parameter);
%else
     %put %str(note==>;-%) a parameter:&p);
%mend ex;

%ex()
%ex(high-low)  


%macro exs (p);
%if %str(&p)= %then
     %put %str(warning ==>;-%(  missing parameter);
%else
     %put %str(note==>;-%) a parameter:&p);
%mend exs;
%exs;
/*error: a character operand was found in the %eval function or %if condition where a numeric*/
/*       operand is required. the condition was: &p=*/
/*error: the macro exs will stop executing.*/
%exs(high->low);


/*************************************************************************
         Difference between %bquote(%quote) and %nrbquote(%nrquote)
*************************************************************************/

 /*the %bquote example has 2 warning messages; the first warning message is 
the first attempt at resolving the value. when it cannot, it tries again.  the 
%nrbquote only has one warning message because after the first failed attempt at
resolving the macro value it masks the &.  however, when we look at the %put 
statements we see that value was generated with %bquote issue a warning the value 
for the %nrbquote value does not.  this is what is meant when we say that %nrbquote 
will mask & and % in the final value. %nrbquote is useful when:
  1)strings that look like macro variable references but are not, so the macro processor 
    should not attempt to resolve them when it next encounters them. 
  2)macro invocations that you do not want the macro processor to attempt to resolve
    when it next encounters them. 
*/
data _null_;
call symput('a','ben&jerry');
run ;

 %let b = %nrbquote( &a ) ;/* warning: apparent symbolic reference jerry not resolved.*/
 %put my name is &b;/* my name is  ben&jerry */

 %let c = %bquote( &a ) ;
/*warning: apparent symbolic reference jerry not resolved.*/
/*warning: apparent symbolic reference jerry not resolved.*/
 %put my name is &c;/* my name is  ben&jerry*/
/*warning: apparent symbolic reference jerry not resolved.*/



/*it will not try to further resolve the macro expression 
if either a & or % sign are present in the macro expression after the first resolution.  */
%let d=%superq( a ) ;/*no warning*/
%put my name is &d;/*my name is  ben&jerry*/

%let jerry=Jerry;
%let name=%superq(a);
%put &name;



/*************************************************************************
  %UPCASE, %SUBSTR, %SCAN, %SYSFUNC return unquoted results,even if 
  the argument was masked by a macro quoting function. while %QUPCASE, 
  %QSUBSTR, %QSCAN, %QSYSFUNC functions mask the returned value at execution
  time. The items masked are the same as the items masked by the %nrbquote
  function. 
*************************************************************************/


%LET X=%NRSTR(%eval(1+2));
%PUT &X;
%PUT %UPCASE(x=&X);/*X=3,unquoted result*/
%PUT %QUPCASE(x=&X);/*X=%EVAL(1+2),keep quoted*/

%LET A=1;
%LET ABC=5;
%LET DEF=%NRSTR(&ABC);
%put def=&def;
%PUT %SUBSTR(&DEF,1,2);/*1,unquoted result*/
%PUT %QSUBSTR(&DEF,1,2);/*&A*/
