

%let car_maker=Audi;

proc print data=sashelp.cars(where=(Make="&car_maker"));
	title "Cars information for &car_maker";
	var Model Type Origin DriveTrain EngineSize;
run;


%let car_maker=Audi;


title1 "Cars information for &car_maker";
title2 "As of &systime &sysday &sysdate";
title3 "Using SAS Version: &sysver";

proc print data=sashelp.cars(where=(Make="&car_maker"));
	var Model Type Origin DriveTrain EngineSize;
run;

%macro classcat;
	data %do i=12 %to 16;
	         age&i
		  %end;
		  ;
		set sashelp.class;
			if age=12 then output age12;
				%do i=13 %to 16;
				else if age=&i then output age&i;
				%end;
	run;
%mend classcat;

/*After interpretation by the macro processor, the program becomes:*/

data age12 age13 age14 age15 age16;
	set sashelp.class;
		if age=12 then output age12;
			else if age=13 then output age13;
			else if age=14 then output age14;
			else if age=15 then output age15;
			else if age=16 then output age16;
run;


%macro Classinfo;

	%do age=12 %to 16;

		proc print data=work.age&age;
			title "Students demographics of age &age in class";
			var Name Sex Height Weight;
		run;
	%end;

%mend Classinfo;

%macro whatstep(  info=
               ,mydata=);
	%if &info=print %then
	%do;
		proc print data=&mydata;
		run;
	%end;
	%else %if &info=report %then
	%do;
		options nodate nonumber ps=18 ls=70 fmtsearch=(sasuser);
			proc report data=&mydata nowd;
			column manager dept sales;
			where sector="se";
			format manager $mgrfmt. dept $deptfmt. sales dollar11.2;
			title "Sales for the Southeast Sector";
		run;
	%end;
%mend whatstep;

options mcompilenote=all;

%macro time;
	%put The current time is %sysfunc
	(time(),time11.2).;
%mend time;
